Subject: Re: Asynchronous crypto layer.

From: Sam Leffler <[email-masked]>
Date: Fri, 29 Oct 2004 13:00:53 -0700

Evgeniy Polyakov wrote:
> On Fri, 29 Oct 2004 12:16:35 -0400 (EDT)
> James Morris <[email-masked]> wrote:
> 
> 
>>On 29 Oct 2004, jamal wrote:
>>
>>
>>>On Fri, 2004-10-29 at 10:06, Evgeniy Polyakov wrote:
>>>
>>>
>>>
>>>>If we have a hardware accelerator chip, than we _already_ have improvements 
>>>>with even the worst async crypto layer, since software and hardware 
>>>>will work in parrallel.
>>>
>>>Thats what i am hoping - and theory points to it. Numbers, numbers
>>>please ;->
>>
>>There's an OpenBSD paper which demonstrates the usefulness of crypto
>>hardware for reducing cpu contention.  I can't get to their web site now,
>>but it's there somewhere under a security link.
> 
> 
> Asynchronous crypto layer was written under impression of those paper.
> OpenBSD layer is very good, but it has some nitpics some of which are really
> not good, but I hope all of them are resolved in my driver.
> 
> You can find paper for example there: http://www.madchat.org/crypto/ocf.pdf

And a paper I wrote explains how I fixed many of the problems with the 
openbsd code in freebsd.

http://www.usenix.org/publications/library/proceedings/bsdcon03/tech/leffler_crypto/leffler_crpto_html/

In the same proceedings you'll also find a horrible paper I wrote about 
some performance tuning I did in my IPsec implementation that uses the 
crypto infrastructure.

http://www.usenix.org/publications/library/proceedings/bsdcon03/tech/full_papers/leffler_ipsec/leffler_ipsec_html/

	Sam